5 REM *** MORSE.BAS ***
7 d=0: REM <- Debug Switch (1=ON)
8 GOSUB 1500
10 m=2681: n=m-250: s=10: r=120: o=10
15 COLOR 63,22
18 GOSUB 1400
20 REM --- Main Loop: F1-F8 Keypress --- 
25 GOSUB 100
30 k=INKEY : IF k<208 OR k>215 THEN GOTO 30
35 GOSUB (k-207)*100
40 GOTO 30
100 REM --- Print Screen ---
105 CLS 
110 LOCATE 12,1: PRINT "AMIGO MORSE CODE TRAINER"
115 LOCATE 2,32: PRINT "F1 - CLEAR SCREEN          F5 - SEND CODE"
120 LOCATE 2,33: PRINT "F2 - ENTER MESSAGE TEXT    F6 - LOAD MSG.DAT"
125 LOCATE 2,34: PRINT "F3 - CODE SPEED = 10 WPM   F7 - SAVE MSG.DAT"
130 LOCATE 2,35: PRINT "F4 - FARNSWORTH = 1.0      F8 - QUIT"
195 RETURN 
200 REM --- Enter Message ---
205 e=2781: f=2432: GOSUB 1100
210 LOCATE 2,3: PRINT "> Enter Message String:"
215 u=m: v=m-250
220 GOSUB 900
225 n=w+1
228 IF d THEN b=228: GOSUB 1200
230 LOCATE 2,3: PRINT "> Current Message:     "
295 RETURN 
300 REM --- Change Speed ---
305 LOCATE 2,11: PRINT "> Up/Down Arrows Change Speed; Enter When Done:"
310 k=INKEY : IF k=0 THEN GOTO 310 
315 IF k=13 THEN GOTO 340
320 IF k=194 AND s<20 THEN s=s+1
325 IF k=195 AND s>5 THEN s=s-1
330 LOCATE 20,34: PRINT s;" WPM ";
335 GOTO 310
340 r=1200/s
345 LOCATE 2,11: PRINT "                                               "
395 RETURN 
400 REM --- Change Spacing ---
405 LOCATE 2,11: PRINT "> Up/Down Arrows Change Spacing; Enter Returns:"
410 k=INKEY : IF k=0 THEN GOTO 410
415 IF k=13 THEN GOTO 440
420 IF k=194 AND o<30 THEN o=o+1
425 IF k=195 AND o>10 THEN o=o-1
430 LOCATE 20,35: PRINT o/10;".";o//10;
435 GOTO 410
440 LOCATE 2,11: PRINT "                                               "
495 RETURN 
500 REM --- Send Code ---
502 r=1200/s-30 REM - Get current dit duration
505 LOCATE 2,15: PRINT "> Sending Message..."
510 q=21449 + 2*(2931-m)
512 IF d THEN b=512: GOSUB 1200
515 FOR p=m TO n STEP -1
520 IF BYTE [p] <> 32 THEN GOTO 525
522 PAUSE 7*r*o/10
524 GOTO 540
525 BYTE [q]=240
530 GOSUB 1000
535 BYTE [q]=252
540 q=q+2
545 NEXT p
550 LOCATE 2,15: PRINT "> Message Sent!     "
555 PAUSE 3000
560 LOCATE 2,15: PRINT "                    "
595 RETURN 
600 REM --- Load MSG.DAT ---
605 e=2681: f=2432: GOSUB 1100
610 LOCATE 2,3: PRINT "> Current Message:     "
615 OPEN "MSG.DAT",R
620 i=m
625 a=FILE 
630 IF a<0 THEN GOTO 650
635 BYTE [i]=a
640 i=i-1
645 GOTO 625
650 CLOSE 
655 n=i+1
658 IF d THEN b=658: GOSUB 1200
695 RETURN 
700 REM --- Save MSG.DAT ---
705 LOCATE 2,25: PRINT "Saving MSG.DAT... ";
710 OPEN "MSG.DAT",W
715 FOR i=m TO n STEP -1
720 FILE =BYTE [i]
725 NEXT i
730 CLOSE 
740 PRINT "Done!"
745 PAUSE 2000
750 LOCATE 2,25: PRINT "                        "
795 RETURN 
800 REM --- Quit ---
805 LOCATE 2,25: PRINT "Quit <Y/N>?"
810 k=INKEY 
815 IF k<>"Y" AND K<>"y" AND k<>"N" AND k<>"n" THEN GOTO 805
820 IF k="Y" OR k="y" THEN GOTO 835
825 LOCATE 2,25: PRINT "           "
830 RETURN 
835 CLS : PRINT "Bye!"
840 END 
900 REM --- Process Keystrokes ---
905 w=u
910 k=INKEY : IF k=0 THEN GOTO 910
915 IF k=13 THEN RETURN 
920 IF k=200 AND w<u THEN w=w+1: BYTE [w]=32: GOTO 910
925 IF k>122 THEN GOTO 910
930 IF k>96 THEN k=k-32
935 IF w>v THEN BYTE [w]=k: w=w-1
940 GOTO 910
1000 REM --- Char-To-Dit/Dah ---
1005 x=PEEK BYTE [p] REM - Get Morse byte from SRAM
1007 IF x=0 THEN RETURN 
1010 y=x&1 REM - Get padding bit
1015 i=1 REM - Reset bit counter
1020 IF ((x SHR i)&1)=y THEN i=i+1: GOTO 1020 REM - Strip padding bits
1030 FOR z=i TO 7
1035 t=(x SHR z) & 1 REM - 1=Dah, 0=Dit
1040 OUTA [24]=0 REM - Unmask Audio Generator
1045 PAUSE (2*t + 1) * r
1050 OUTA [24]=1
1055 PAUSE r
1060 NEXT z
1065 PAUSE 3*r*o/10
1095 RETURN 
1100 REM --- Clear Screen Section ---
1105 h=" "
1110 IF d THEN h="."
1115 FOR g=e TO f STEP -1
1120 BYTE [g]=h
1125 NEXT g
1195 RETURN 
1200 REM --- Debug ---
1203 REM ...Adjust these as needed...
1205 LOCATE 0,29: PRINT "Line ";b;" i=";i;" p=";p;" x=";x;" y=";y;" z=";z
1210 IF INKEY =0 THEN GOTO 1210
1215 e=1481: f=1428: GOSUB 1100
1295 RETURN 
1300 REM --- Variables ---
1302 REM - a=FILE char from/to MSG.DAT
1304 REM - b=debug statement line #
1308 REM - d=debug switch (0=OFF)
1310 REM - e,f=start,end screen location of string to clear
1312 REM - g=clear string index
1314 REM - h=clear string char (" "=normal; "."=debug)
1316 REM - i=an index in several routines
1318 REM - k=keystroke from INKEY
1319 REM - m,n,p=start,end, index of message text (up to 250 chars)
1320 REM - o=inter-character spacing mulitplier
1321 REM - q=foreground palette memory location of current message char
1322 REM - r=dit duration in ms; corrects for software run time
1323 REM - s=desired character code speed in wpm
1324 REM - t=dit (1) or dah (3) timer
1325 REM - u,v=start,end of keystroke processing string
1326 REM - w=index for keystroke processing
1328 REM - x=Morse data byte
1330 REM - y=padding bit (0 or 1)
1332 REM - z=send data bits loop index
1400 REM --- Start Audio Counter ---
1405 OUTA [24]=1
1410 FRQA = 130382 REM - 700Hz
1415 CTRA = %00100 SHL 26 + 24
1495 RETURN 
1500 REM --- Dit-Dah Data ---
1502 CLS 
1544 POKE 44,204
1546 POKE 46,171
1548 POKE 48,248
1549 POKE 49,247
1550 POKE 50,231
1551 POKE 51,199
1552 POKE 52,135
1553 POKE 53,7
1554 POKE 54,8
1555 POKE 55,24
1556 POKE 56,56
1557 POKE 57,120
1561 POKE 61,136
1563 POKE 63,51
1565 POKE 65,191
1566 POKE 66,16
1567 POKE 67,80
1568 POKE 68,32
1569 POKE 69,127
1570 POKE 70,79
1571 POKE 71,96
1572 POKE 72,15
1573 POKE 73,63
1574 POKE 74,239
1575 POKE 75,160
1576 POKE 76,47
1577 POKE 77,192
1578 POKE 78,64
1579 POKE 79,224
1580 POKE 80,111
1581 POKE 81,176
1582 POKE 82,95
1583 POKE 83,31
1584 POKE 84,128
1585 POKE 85,159
1586 POKE 86,143
1587 POKE 87,223
1588 POKE 88,144
1589 POKE 89,208
1590 POKE 90,48
1595 RETURN 
